Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Debian/Ubuntu   

Target version: 1.10.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Add armv7 and armv8 Debian/Ubuntu packages to our repositories.

Related issues:

Related to Packaging - Feature #13686: armv8/arm64 Debian package support Closed 02/12/2016

History

#1 - 09/24/2015 07:31 AM - Dominic Cleal

Per a conversation on #theforeman, we've had two ARM server donations.

debian01.datacentred.theforeman.org (as it'll be known) is an armv8 server running on datacentred's OpenStack cloud.  I've connected it to our

Puppet infra, but it has a few errors that will need fixing.  I'll join it in Jenkins in a moment (

http://ci.theforeman.org/computer/debian01.datacentred.theforeman.org/)

sw04.mrel.de/sw04-mrel-de.cloud.online.net is an armv7 server.  Also connected up to Puppet now, which is beginning to run.

Once our regular slave Puppet manifests are working and the builders are available for use in Jenkins, we'll probably then need to:

1. add ARM pbuilder configs

2. update core/dep build jobs to accept architecture as a parameter

3. update build job matrixes to add architecture

#2 - 09/24/2015 08:56 AM - Dominic Cleal

https://github.com/theforeman/foreman-infra/pull/187 should help fix some Puppet errors and add the necessary pbuilder configs.

#3 - 09/25/2015 07:35 AM - Dominic Cleal

- Parent task set to #1

Both slaves are now connected and our Puppet manifests are adapted, including with ARM pbuilder configs.

They're both unable to access freight services for uploading built packages however - https://github.com/theforeman/foreman-infra/pull/189 should fix

this.

https://github.com/theforeman/foreman-infra/pull/190 should then adapt the deb_corepackage Jenkins job to build core packages on non-x86

platforms (due to different pbuilder configs).  Once that's in, we can add the ARM platforms to the matrix job and see how well it works.  The same

change will be needed for the deb_dependency job.

#4 - 09/25/2015 07:35 AM - Dominic Cleal

- Parent task deleted (#1)

#5 - 09/25/2015 07:36 AM - Dominic Cleal

- Tracker changed from Task to Feature

- Target version deleted (0.1-2)

#6 - 10/13/2015 02:58 AM - Dominic Cleal
The ARM builders can now access freight, and freight is reconfigured to build armhf and arm64 archives.

The deb_dependency job is updated to also run on armv7 and armv8 builders for packages, and it seems to successfully be building arm64 packages

on jessie/trusty.

It's failing to build armhf packages, e.g. 

http://ci.theforeman.org/job/packaging_build_deb_dependency/arch=armv7,label=debian,os=trusty/966/console

+ sudo pdebuild-trusty

W: /root/.pbuilderrc does not exist

/usr/bin/pdebuild: line 39: /dev/fd/62: No such file or directory

Build step 'Execute shell' marked build as failure

#7 - 10/20/2015 05:18 AM - Dominic Cleal

The /dev issue was due to udev being missing on the armv7 slave, installed and it's working OK now.

ruby-rkerberos built successfully on both, and we now have armhf and arm64 packages in nightly repos.

ruby-mysql2 had issues with the tests, probably because I had to enable the updates and security components in the pbuilder configs to get the initial

buildroot to work properly.  The tests have since been fixed in Debian upstream, but we opted to remove them as backporting the changes was going

to get tricky: https://github.com/theforeman/foreman-packaging/pull/844.  ruby-mysql2 is now built for precise and wheezy on armhf.

With both arch-specific deps built, the smart proxy, CLI and related packages should now work on armhf and arm64.

Attempting to build Foreman core remains.

#8 - 11/10/2015 09:18 AM - Dominic Cleal

I attempted to build Foreman core on armhf today:

jessie/trusty on armhf appear to be fine (though trusty failed due to #12431)

wheezy on armhf failed because it uses V8.  We could add wheezy-backports and use nodejs there too, or disable this combination.

precise on armhf failed because the Brightbox Ruby PPA is x86-only

And on arm64:

jessie/trusty failed as nodejs isn't built for arm64.  We could add an external repo or wait until the next stable releases when both distros look like

they'll ship arm64 builds.

#9 - 11/10/2015 09:41 AM - Dominic Cleal

https://github.com/theforeman/foreman-infra/commit/6555e45 enables builds on armv7 for jessie and trusty in light of the above.

I don't mind adding wheezy-backports if somebody wishes to wheezy to build it with nodejs - though this would then make it a dependency for x86

too.  I don't mind what we do about arm64/armv8 either (wait, or add another repo for non-x86).

#10 - 11/10/2015 10:19 AM - Ewoud Kohl van Wijngaarden

I'd prefer not supporting wheezy on ARM. IMHO it's too new a platform to consider any legacy where users would have trouble upgrading.

#11 - 11/10/2015 10:21 AM - Anonymous

The same IMHO for precise

#12 - 11/10/2015 10:22 AM - Ewoud Kohl van Wijngaarden

Michael Moll wrote:

The same IMHO for precise

 Obviously what I thought, but forgot to write down.

#13 - 11/10/2015 10:23 AM - Dominic Cleal

Yep, fine by me.  I don't think precise is even possible, thankfully.

The only question that remains in my mind is what to do about arm64 on jessie/trusty.  Whether to try adding the nodesource repos (

https://github.com/nodesource/distributions) to those build envs or leave it with just deps (smart proxy) support until 16.04 and stretch.

#14 - 11/10/2015 10:49 AM - Ewoud Kohl van Wijngaarden

I'd say the latter: just deps and full support with 16.04 and strech.
#15 - 11/10/2015 11:10 AM - Anonymous

arm64 is basically so new, nobody has the hardware right now. Ubuntu/xenial is no problem for sure. AFAICT, Debian/jesse also has full support for

it, so that would be nice, but armhf is the primary target for now anyway.

#16 - 11/11/2015 04:21 AM - Dominic Cleal

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

- translation missing: en.field_release set to 63

Okay, thanks all.  I'll close this for now and have updated the docs over at https://github.com/theforeman/theforeman.org/pull/477.  We've got arm64

packages for the smart proxy at least, and will bring in Foreman core for the new OSes when we add them.

#17 - 02/12/2016 08:10 AM - Dominic Cleal

- Related to Feature #13686: armv8/arm64 Debian package support added

#18 - 02/12/2016 08:11 AM - Dominic Cleal

Our arm64 builder's been offline since December, and the sponsor has confirmed that they're not going to be able to provide it any more so we're

without arm64 builds.  I've left #13686 open to track re-enabling that if we can get an arm64 server again.
